# WP Data Access

* Contributors: [PeterSchulzNL](https://wpdataaccess.com/)
* Donate link: https://www.paypal.me/kpsch
* Requires at least: WordPress 4.8.3
* Tested up to: WordPress 6.0
* Stable tag: 5.2.2
* License: GPLv2 or later
* License URI: http://www.gnu.org/licenses/gpl-2.0.html

WP Data Access is the #1 plugin for creating professional tables, charts and data entry forms directly from the WordPress dashboard

## Description
WP Data Access is a powerful data administration, publication, and development tool. An intuitive interface helps to create responsive tables and charts for back-end and front-end usage in just minutes. Highly customizable CRUD pages are generated on the fly. No programming skills required.

The plugin supports more complex features for advanced users, including remote database and file access, master-detail pages, lookups, inline editing, advanced search options, dynamic hyperlinks, WordPress media library integration, WordPress role management integration and many more. Programmers can also benefit from the WP Data Access API, which can be used to access remote databases and data files directly from their PHP code.

### Tables
> Use the Data Publisher to create professional data tables for back-end and front-end usage.

#### Levels
* Easy level: no coding skills required
* Advanced level: JSON configuration
* Expert level: add custom JavaScript functions

#### Features
* Global searching and sorting
* Many static and interactive filters
* Custom CSS styling [[demo]](https://wpdataaccess.com/demos/demos-data-publisher/data-publisher-free-styling/)
* Server-side processing (default)
* Client-side processing [[demo]](https://wpdataaccess.com/row-grouping-client-side/)
* Export to CSV, Excel, PDF and SQL, Print and Copy buttons (PREMIUM) [[demo]](https://wpdataaccess.com/search-panes-demo-without-buttons/)
* Integrated geolocation search (PREMIUM) [[demo]](https://wpdataaccess.com/publication-using-geolocation/)
* Multiple advanced search options (PREMIUM)
* Interactive Search Builder (PREMIUM) [[demo]](https://wpdataaccess.com/search-builder-demo/)
* Interactive Search Panes (PREMIUM) [[demo]](https://wpdataaccess.com/search-panes-demo-without-buttons/)
* Custom queries and custom post types (PREMIUM)

### Remote database and file access
> WP Data Access supports access to several remote databases and remote data files.

Database tables created from remote database connections and remote data files are available from all plugin tools. Publications, charts, and projects can utilize these database tables. The remote connection wizard helps premium users set up the connection. Documentation is available for free users as well (requires DBMS and OS knowledge and root access).

#### Supporting

* SQL Server
* Oracle
* ProgreSQL
* MariaDB
* MySQL
* MS Access (file based)
* CSV files
* JSON files
* XML files

### Charts
> Create charts from SQL queries. The Query Builder is available to manage and test your SQL queries.

* Google Charts integration
* Bar, column, line and pie charts, histograms, gauges and data tables are supported [[demo]](https://wpdataaccess.com/2022/06/16/chart-demo/)
* The Visual Query Builder is a helpful premium feature for users with little or no SQL knowledge.

### Forms
> Use Data Projects to create data driven WordPress apps that can be executed on the back-end and front-end. Projects are highly customizable using templates.

* Auto generated CRUD pages
* Parent-child relationships
* Lookups
* Remote and local databases
* WordPress role integration
* WordPress media library integration
* Accessible from the WordPress dashboard and public pages
* DataForms - fully responsive apps for back-end and front-end (PREMIUM) [[demo]](https://wpdataaccess.com/demos/data-forms-project-demo/)
* Inline editing (PREMIUM)
* Full-text search (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Data Explorer
> The Data Explorer helps WordPress users to manage local and remote data and databases from a single location.

* Manage local and remote data and databases
* Import SQL and CSV files (supports ZIP for large import files)
* Exports to SQL, CSV, JSON and XML (supports extremely large table exports)
* Rename, copy, truncate, drop, optimize and alter tables
* Change table and column settings (advanced search, geolocation, inline editing and more)
* Enable WordPress Media Library integration for specific table columns
* Enable inline editing for specific table columns (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Query Builder
> Execute SQL queries directly from the WordPress dashboard.

* Work on multiple SQL queries simultaneously (using tabs)
* Save and reuse queries (for publications and charts)
* Protects WordPress table structures and data
* Interactive Visual Query Builder for user with limited or no SQL knowledge (PREMIUM)

### Geolocation maps
> Create a searchable geolocation map from a database table containing geolocation information.

* Google Maps integration (PREMIUM)
* Define map settings per table (PREMIUM)
* Dynamic marker layout configuration (PREMIUM)
* Use static or user location (PREMIUM)
* Search map within adjustable radius (PREMIUM) [[demo]](https://wpdataaccess.com/demos/geolocation-demo/)

### Dashboards and widgets
> Dashboards are designed for back-end usage. Widgets are highly customizable and can be shown on dashboards (back-end), webpages (front-end), and external websites.

* Manage all your data in one location
* Share your data widgets anywhere (PREMIUM)
* Give specific users and user groups access to locked dashboards (PREMIUM)
* Allow users to create their own dashboards (PREMIUM)

### Data Designer
> Create tables and indexes using an intuitive user interface.

* Create tables and indexes
* Modify tables and indexes
* Supports reverse engineering and reconciliation

### Plugin Settings
> WP Data Access is highly customizable. Many detailed plugin settings are available to manage the plugin user interface and behavior.

### Useful Links

[» Plugin Website](https://wpdataaccess.com/)
[» Documentation](https://wpdataaccess.com/docs/documentation/)
[» Demos](https://wpdataaccess.com/demos/)

## License

WP Data Access is licensed under the [GPL v2](http://www.gnu.org/licenses/gpl-2.0.html) or later.

> This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

> This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

> You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
